<template>
    <div class="edit-view">
        <el-form
            :model="formData"
            :rules="rules"
            ref="form"
            label-width="52px"
            label-position="right"
            size="small"
            style="max-width: 500px;"
        >
            <el-form-item prop="name" label="名称">
                <el-input v-model="formData.name"></el-input>
            </el-form-item>
            <el-form-item prop="startTime" label="时间">
                <!-- <el-date-picker
                    v-model="formData.startTime"
                    type="date"
                    value-format="yyyy-MM-dd"
                    placeholder="选择日期"
                    style="width: 190px; margin-right: 20px"
                >
                </el-date-picker>
                至
                <el-date-picker
                    v-model="formData.endTime"
                    type="date"
                    value-format="yyyy-MM-dd"
                    placeholder="选择日期"
                    style="width: 190px; margin-left: 20px"
                >
                </el-date-picker> -->
                <el-date-picker
                    v-model="dateRange"
                    type="daterange"
                    value-format="yyyy-MM-dd"
                    start-placeholder="请选择开始时间"
                    end-placeholder="请选择结束时间"
                    range-separator="至"
                    style="width: 100%"
                >
                </el-date-picker>
            </el-form-item>
            <el-form-item prop="address" label="地点">
                <el-input v-model="formData.address"></el-input>
            </el-form-item>
            <el-form-item prop="status" label="状态">
                <el-select v-model="formData.status" clearable filterable placeholder="请选择">
                    <el-option v-for="item in statusOptions" :key="item.value" :label="item.label" :value="item.value">
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving" type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving" type="danger" v-if="formData.id">删除 </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
export default {
    name: 'PerformanceEdit',
    created() {
        if (this.$route.query.id) {
            this.$http
                .get('performance/get/' + this.$route.query.id)
                .then(res => {
                    this.formData = res;
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        }
    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {},
            statusOptions: [
                { label: '报名中', value: 'APPLY' },
                { label: '已结束', value: 'END' }
            ],
            dateRange: ''
        };
    },
    methods: {
        onSave() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            let data = { ...this.formData };
            data.startTime = this.dateRange[0];
            data.endTime = this.dateRange[1];
            this.saving = true;
            this.$http
                .post('/performance/save', data, { body: 'json' })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/performance/del/${this.formData.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error((e || {}).error || '删除失败');
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
